Subject: bug#78321: libtool fails to run ldconfig correctly on GNU/Linux

From: Bob Friesenhahn <[email-masked]>
Date: Tue, 13 May 2025 04:38:46 -0700

Libtool works on many different operating systems, which behave in various
ways. Some OSs will find a new library automatically if it is installed in
the existing configured library paths.

The library installed might not ever be intended to be used by the
currently executing OS because it is part of new distribution builds.

Sometimes libraries are installed privately, using hard-coded run-paths in
the dependent binaries. This is very common when a different version of the
software is to be run than the OS is designed to support.

Expecting a libtool (merely a shell script!) maintainer to write such a
document is unreasonable. It is possible that GNU has such a document
specific to GNU systems.

Bob

On Tue, May 13, 2025, 4:12 AM Reuben Thomas via bug-libtool via Bug reports
for the GNU libtool shared library maintenance tool <[email-masked]>
wrote:

> On Mon, 12 May 2025 at 20:08, Ileana Dumitrescu <
> [email-masked]> wrote:
> Thanks for the quick reply!
>
>
>> This was also previously reported in bug#30402 [1]
>
>
> By me!
>
> Updating the shared library cache from scratch by executing ldconfig in
>> libtool could cause a lot of headache for developers,
>
>
> It would be good to briefly say why it's a problem. (I don't know, and
> Debian seems to run ldconfig whenever I install or uninstall a shared
> library, so it doesn't seem a big deal at least there.)
>
> The following could be added:
>>
>> """
>> After a 'make install' for many GNU/Linux systems, 'ldconfig LIBDIR' may
>> need to be executed to help locate newly installed libraries, but you
>> should consult with a system administrator before updating the shared
>> library cache as this should be done with great care and consideration.
>> """
>>
>
> Again, it would be good if possible to briefly outline potential problems.
> Then the informational message is pretty much complete: it will
>
>    - explains that users may now need to run ldconfig
>    - gives them the command to run
>    -
> *says why this might not be a good idea (this bit currently missing!) *
>    - explains what won't work until the command is run
>
> --
> https://rrt.sc3d.org
>